// TsStreamCallback.h: R[obNp`
//
//////////////////////////////////////////////////////////////////////

#if !defined(_TSSTREAMCALLBACK_H_)
#define _TSSTREAMCALLBACK_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "../common/datetime.h"

// R[obNAPI̒`
typedef void (CALLBACK PF_TSENGINE_CALLBACK)(UINT uType,WORD wStreamID,LPVOID pData,DWORD dwVal,LPVOID lpContext);

// ȂB
#define TSENG_CALLBACK_NONE				(0x00000000)

// pPbgo
//   wStreamID = o͔ԍ(ftHg=0,Pȍ~͎w肵ꍇ)
//   pData     = pPbgz擪
//   dwVal     = pPbg
#define TSENG_CALLBACK_PACKET			(0x00000001)

// Xg[̃ZbgN
//   wStreamID = VTsID
//   pData     = NULL
//   dwVal     = 1ȂXg[̏I\
#define TSENG_CALLBACK_STREAM_RESET		(0x00000002)


// PATf[^̒ʒm
//   wStreamID = TransportStreamID
//   pData     = struct TAG_TSCB_PATITEM z
//   dwVal     = ڐ
#define TSENG_CALLBACK_PAT_RECIEVE		(0x00000010)
	struct TAG_TSCB_PATITEM
	{
		WORD wProgramID;
		WORD wPID;
	};

// PMTf[^̒ʒm
//   wStreamID = ProgramID
//   pData     = struct TAG_BONTSCB_PMTITEM z
//   dwVal     = ڐ
#define TSENG_CALLBACK_PMT_RECIEVE		(0x00000011)
	struct TAG_TSCB_PMTITEM
	{
		BYTE byType;
		WORD wPID;
	};

// lbg[NID̒ʒm
//   wStreamID = NetworkID(p[VTS̎͑Srbg1IDƂȂ͂)
//   pData     = lbg[N(Shift-JISϊρA'\0'I[)
//   dwVal     = MpPbg 0=NIT/1=SIT
#define TSENG_CALLBACK_NIT_RECIEVE		(0x00000012)

// lbg[NID̒ʒm
//   wStreamID = NetworkID
//   pData     = 
//   dwVal     = TransportStreamID
#define TSENG_CALLBACK_SATELLITE_INFO	(0x00000013)
	struct TAG_TSCB_SATELLITE
	{
		double	lfFrequency;	// `g(MHz)
		double	lfPosition;		// qʒu(x)
		BOOL	bEastFlg;		// o=TRUE / a=FALSE
		BYTE	byPolarization;	// Δg 0= / 1= / 2= / 3=E
		BYTE	byModulation;	// ϒ 1=QPQK / 8=TC8PSK(BSDp)
		double	lfRate;			// MBit/sec
		BYTE	byFEC_inner;	//  1=1/2 / 2=2/3 / 3=3/4 / 4=5/6 / 5=7/8 / 8=(BSDp) / 15=Ȃ
	};

// TSXg[Ԃ̒ʒm(Kił͂TbɂP)
//   wStreamID = 0
//   pData     = &struct TAG_BONTSCB_TIME
//   dwVal     = 0
#define TSENG_CALLBACK_TIME_RECIEVE		(0x00000020)
	struct TAG_TSCB_TIME
	{
		DateTime stDateTime;
		DWORD dwTimeBCD;	// abc`
		BYTE byHour;
		BYTE byMin;
		BYTE bySec;		
	};

// T[rX̒ʒm
//   wStreamID = ProgramID
//   pData     = T[rX(Shift-JISϊρA'\0'I[)
//   dwVal     = 0
#define TSENG_CALLBACK_SDT_RECIEVE		(0x00000030)

#endif // !defined(_TSSTREAMCALLBACK_H_)
